diff --git a/src/backend/optimizer/plan/planner.c b/src/backend/optimizer/plan/planner.c
index ef2eaea..ec99718 100644
--- a/src/backend/optimizer/plan/planner.c
+++ b/src/backend/optimizer/plan/planner.c
@@ -131,9 +131,6 @@ static void standard_qp_callback(PlannerInfo *root, void *extra);
 static double get_number_of_groups(PlannerInfo *root,
 					 double path_rows,
 					 grouping_sets_data *gd);
-static Size estimate_hashagg_tablesize(Path *path,
-						   const AggClauseCosts *agg_costs,
-						   double dNumGroups);
 static RelOptInfo *create_grouping_paths(PlannerInfo *root,
 					  RelOptInfo *input_rel,
 					  PathTarget *target,
@@ -148,6 +145,18 @@ static void consider_groupingsets_paths(PlannerInfo *root,
 							grouping_sets_data *gd,
 							const AggClauseCosts *agg_costs,
 							double dNumGroups);
+static void sort_agg_partial_grouped_paths(PlannerInfo *root, List *pathlist,
+							   AggClauseCosts *agg_final_costs,
+							   double dNumGroups,
+							   RelOptInfo *grouped_rel,
+							   PathTarget *gather_target,
+							   PathTarget *group_target);
+static void hash_agg_partial_grouped_path(PlannerInfo *root, Path *path,
+							  AggClauseCosts *agg_final_costs,
+							  double dNumGroups,
+							  RelOptInfo *grouped_rel,
+							  PathTarget *gather_target,
+							  PathTarget *group_target);
 static RelOptInfo *create_window_paths(PlannerInfo *root,
 					RelOptInfo *input_rel,
 					PathTarget *input_target,
@@ -185,6 +194,8 @@ static PathTarget *make_sort_input_target(PlannerInfo *root,
 					   bool *have_postponed_srfs);
 static void adjust_paths_for_srfs(PlannerInfo *root, RelOptInfo *rel,
 					  List *targets, List *targets_contain_srfs);
+static Path *adjust_path_for_unique_group_keys(PlannerInfo *root, Path *path,
+								  PathTarget *target);
 
 
 /*****************************************************************************
@@ -544,6 +555,7 @@ subquery_planner(PlannerGlobal *glob, Query *parse,
 	memset(root->upper_rels, 0, sizeof(root->upper_rels));
 	memset(root->upper_targets, 0, sizeof(root->upper_targets));
 	root->processed_tlist = NIL;
+	root->max_sortgroupref = 0;
 	root->grouping_map = NULL;
 	root->minmax_aggs = NIL;
 	root->qual_security_level = 0;
@@ -1519,7 +1531,7 @@ inheritance_planner(PlannerInfo *root)
 									 returningLists,
 									 rowMarks,
 									 NULL,
-									 SS_assign_special_param(root)));
+									 SS_assign_special_param(root)), false);
 }
 
 /*--------------------
@@ -1922,7 +1934,8 @@ grouping_planner(PlannerInfo *root, bool inheritance_update,
 				newpath = (Path *) create_projection_path(root,
 														  current_rel,
 														  subpath,
-														  scanjoin_target);
+														  scanjoin_target,
+														  false);
 				lfirst(lc) = newpath;
 			}
 		}
@@ -1966,6 +1979,7 @@ grouping_planner(PlannerInfo *root, bool inheritance_update,
 												grouping_target,
 												&agg_costs,
 												gset_data);
+
 			/* Fix things up if grouping_target contains SRFs */
 			if (parse->hasTargetSRFs)
 				adjust_paths_for_srfs(root, current_rel,
@@ -2134,7 +2148,7 @@ grouping_planner(PlannerInfo *root, bool inheritance_update,
 		}
 
 		/* And shove it into final_rel */
-		add_path(final_rel, path);
+		add_path(final_rel, path, false);
 	}
 
 	/*
@@ -3540,40 +3554,6 @@ get_number_of_groups(PlannerInfo *root,
 }
 
 /*
- * estimate_hashagg_tablesize
- *	  estimate the number of bytes that a hash aggregate hashtable will
- *	  require based on the agg_costs, path width and dNumGroups.
- *
- * XXX this may be over-estimating the size now that hashagg knows to omit
- * unneeded columns from the hashtable. Also for mixed-mode grouping sets,
- * grouping columns not in the hashed set are counted here even though hashagg
- * won't store them. Is this a problem?
- */
-static Size
-estimate_hashagg_tablesize(Path *path, const AggClauseCosts *agg_costs,
-						   double dNumGroups)
-{
-	Size		hashentrysize;
-
-	/* Estimate per-hash-entry space at tuple width... */
-	hashentrysize = MAXALIGN(path->pathtarget->width) +
-		MAXALIGN(SizeofMinimalTupleHeader);
-
-	/* plus space for pass-by-ref transition values... */
-	hashentrysize += agg_costs->transitionSpace;
-	/* plus the per-hash-entry overhead */
-	hashentrysize += hash_agg_entry_size(agg_costs->numAggs);
-
-	/*
-	 * Note that this disregards the effect of fill-factor and growth policy
-	 * of the hash-table. That's probably ok, given default the default
-	 * fill-factor is relatively high. It'd be hard to meaningfully factor in
-	 * "double-in-size" growth policies here.
-	 */
-	return hashentrysize * dNumGroups;
-}
-
-/*
  * create_grouping_paths
  *
  * Build a new upperrel containing Paths for grouping and/or aggregation.
@@ -3604,8 +3584,8 @@ create_grouping_paths(PlannerInfo *root,
 	Path	   *cheapest_path = input_rel->cheapest_total_path;
 	RelOptInfo *grouped_rel;
 	PathTarget *partial_grouping_target = NULL;
-	AggClauseCosts agg_partial_costs;	/* parallel only */
-	AggClauseCosts agg_final_costs; /* parallel only */
+	AggClauseCosts agg_final_costs;
+	bool		agg_final_costs_known = false;
 	Size		hashaggtablesize;
 	double		dNumGroups;
 	double		dNumPartialGroups = 0;
@@ -3694,7 +3674,7 @@ create_grouping_paths(PlannerInfo *root,
 								   (List *) parse->havingQual);
 		}
 
-		add_path(grouped_rel, path);
+		add_path(grouped_rel, path, false);
 
 		/* No need to consider any other alternatives. */
 		set_cheapest(grouped_rel);
@@ -3787,6 +3767,13 @@ create_grouping_paths(PlannerInfo *root,
 	}
 
 	/*
+	 * Collect statistics about aggregates for estimating costs of performing
+	 * aggregation in parallel.
+	 */
+	MemSet(&agg_final_costs, 0, sizeof(AggClauseCosts));
+	agg_final_costs_known = false;
+
+	/*
 	 * Before generating paths for grouped_rel, we first generate any possible
 	 * partial paths; that way, later code can easily consider both parallel
 	 * and non-parallel approaches to grouping.  Note that the partial paths
@@ -3797,6 +3784,9 @@ create_grouping_paths(PlannerInfo *root,
 	if (try_parallel_aggregation)
 	{
 		Path	   *cheapest_partial_path = linitial(input_rel->partial_pathlist);
+		AggClauseCosts agg_partial_costs;
+
+		MemSet(&agg_partial_costs, 0, sizeof(AggClauseCosts));
 
 		/*
 		 * Build target list for partial aggregate paths.  These paths cannot
@@ -3812,26 +3802,12 @@ create_grouping_paths(PlannerInfo *root,
 												 cheapest_partial_path->rows,
 												 gd);
 
-		/*
-		 * Collect statistics about aggregates for estimating costs of
-		 * performing aggregation in parallel.
-		 */
-		MemSet(&agg_partial_costs, 0, sizeof(AggClauseCosts));
-		MemSet(&agg_final_costs, 0, sizeof(AggClauseCosts));
 		if (parse->hasAggs)
 		{
 			/* partial phase */
 			get_agg_clause_costs(root, (Node *) partial_grouping_target->exprs,
 								 AGGSPLIT_INITIAL_SERIAL,
 								 &agg_partial_costs);
-
-			/* final phase */
-			get_agg_clause_costs(root, (Node *) target->exprs,
-								 AGGSPLIT_FINAL_DESERIAL,
-								 &agg_final_costs);
-			get_agg_clause_costs(root, parse->havingQual,
-								 AGGSPLIT_FINAL_DESERIAL,
-								 &agg_final_costs);
 		}
 
 		if (can_sort)
@@ -3871,7 +3847,8 @@ create_grouping_paths(PlannerInfo *root,
 														 parse->groupClause,
 														 NIL,
 														 &agg_partial_costs,
-														 dNumPartialGroups));
+														 dNumPartialGroups),
+										 false);
 					else
 						add_partial_path(grouped_rel, (Path *)
 										 create_group_path(root,
@@ -3880,7 +3857,8 @@ create_grouping_paths(PlannerInfo *root,
 														   partial_grouping_target,
 														   parse->groupClause,
 														   NIL,
-														   dNumPartialGroups));
+														   dNumPartialGroups),
+										 false);
 				}
 			}
 		}
@@ -3911,7 +3889,8 @@ create_grouping_paths(PlannerInfo *root,
 												 parse->groupClause,
 												 NIL,
 												 &agg_partial_costs,
-												 dNumPartialGroups));
+												 dNumPartialGroups),
+								 false);
 			}
 		}
 	}
@@ -3919,17 +3898,36 @@ create_grouping_paths(PlannerInfo *root,
 	/* Build final grouping paths */
 	if (can_sort)
 	{
+		List	   *pathlist = input_rel->pathlist;
+		int			nplain = list_length(input_rel->pathlist);
+		int			i;
+
+		/*
+		 * The grouped paths created out of grouped base relations or joins
+		 * can be treated almost identically here (the major difference is
+		 * that their targetlists contain GroupedVars instead aggregate input
+		 * vars, but this is handled by using the appropriate value of
+		 * AggSplit), so process them in the same loop.
+		 */
+		if (input_rel->gpi != NULL && input_rel->gpi->pathlist != NIL)
+			pathlist = list_concat(list_copy(pathlist),
+								   input_rel->gpi->pathlist);
+
 		/*
 		 * Use any available suitably-sorted path as input, and also consider
 		 * sorting the cheapest-total path.
 		 */
-		foreach(lc, input_rel->pathlist)
+		i = 0;
+		foreach(lc, pathlist)
 		{
 			Path	   *path = (Path *) lfirst(lc);
 			bool		is_sorted;
+			bool		is_grouped;
 
 			is_sorted = pathkeys_contained_in(root->group_pathkeys,
 											  path->pathkeys);
+			is_grouped = i >= nplain;
+
 			if (path == cheapest_path || is_sorted)
 			{
 				/* Sort the cheapest-total path if it isn't already sorted */
@@ -3943,12 +3941,39 @@ create_grouping_paths(PlannerInfo *root,
 				/* Now decide what to stick atop it */
 				if (parse->groupingSets)
 				{
+					/*
+					 * No grouping should have taken place at base relation /
+					 * join level, i.e. pathlist should be equal to
+					 * input_rel->pathlist.
+					 */
+					Assert(!is_grouped);
+
 					consider_groupingsets_paths(root, grouped_rel,
 												path, true, can_hash, target,
 												gd, agg_costs, dNumGroups);
 				}
 				else if (parse->hasAggs)
 				{
+					AggStrategy aggstrategy;
+					AggSplit	aggsplit;
+
+					if (!is_grouped)
+					{
+						aggstrategy = parse->groupClause ? AGG_SORTED : AGG_PLAIN;
+						aggsplit = AGGSPLIT_SIMPLE;
+					}
+					else
+					{
+						/*
+						 * Like above, no grouping of base relation is not
+						 * possible w/o this.
+						 */
+						Assert(parse->groupClause);
+
+						aggstrategy = AGG_SORTED;
+						aggsplit = AGGSPLIT_FINAL_DESERIAL;
+					}
+
 					/*
 					 * We have aggregation, possibly with plain GROUP BY. Make
 					 * an AggPath.
@@ -3958,12 +3983,12 @@ create_grouping_paths(PlannerInfo *root,
 											 grouped_rel,
 											 path,
 											 target,
-											 parse->groupClause ? AGG_SORTED : AGG_PLAIN,
-											 AGGSPLIT_SIMPLE,
+											 aggstrategy,
+											 aggsplit,
 											 parse->groupClause,
 											 (List *) parse->havingQual,
 											 agg_costs,
-											 dNumGroups));
+											 dNumGroups), false);
 				}
 				else if (parse->groupClause)
 				{
@@ -3978,7 +4003,7 @@ create_grouping_paths(PlannerInfo *root,
 											   target,
 											   parse->groupClause,
 											   (List *) parse->havingQual,
-											   dNumGroups));
+											   dNumGroups), false);
 				}
 				else
 				{
@@ -3986,122 +4011,50 @@ create_grouping_paths(PlannerInfo *root,
 					Assert(false);
 				}
 			}
+
+			i++;
 		}
 
 		/*
-		 * Now generate a complete GroupAgg Path atop of the cheapest partial
-		 * path.  We can do this using either Gather or Gather Merge.
+		 * Compute agg_final_costs iff the aggregation should take place in 2
+		 * steps.
 		 */
-		if (grouped_rel->partial_pathlist)
+		if (parse->hasAggs &&
+			(grouped_rel->partial_pathlist ||
+			 (input_rel->gpi != NULL && input_rel->gpi->partial_pathlist)))
 		{
-			Path	   *path = (Path *) linitial(grouped_rel->partial_pathlist);
-			double		total_groups = path->rows * path->parallel_workers;
+			get_agg_clause_costs(root, (Node *) target->exprs,
+								 AGGSPLIT_FINAL_DESERIAL,
+								 &agg_final_costs);
+			get_agg_clause_costs(root, parse->havingQual,
+								 AGGSPLIT_FINAL_DESERIAL,
+								 &agg_final_costs);
 
-			path = (Path *) create_gather_path(root,
-											   grouped_rel,
-											   path,
-											   partial_grouping_target,
-											   NULL,
-											   &total_groups);
+			agg_final_costs_known = true;
+		}
 
-			/*
-			 * Since Gather's output is always unsorted, we'll need to sort,
-			 * unless there's no GROUP BY clause or a degenerate (constant)
-			 * one, in which case there will only be a single group.
-			 */
-			if (root->group_pathkeys)
-				path = (Path *) create_sort_path(root,
-												 grouped_rel,
-												 path,
-												 root->group_pathkeys,
-												 -1.0);
+		/*
+		 * Gather grouped partial paths and apply AGG_SORTED to them.
+		 */
+		if (grouped_rel->partial_pathlist)
+			sort_agg_partial_grouped_paths(root,
+										   grouped_rel->partial_pathlist,
+										   &agg_final_costs,
+										   dNumGroups, grouped_rel,
+										   partial_grouping_target, target);
 
-			if (parse->hasAggs)
-				add_path(grouped_rel, (Path *)
-						 create_agg_path(root,
-										 grouped_rel,
-										 path,
-										 target,
-										 parse->groupClause ? AGG_SORTED : AGG_PLAIN,
-										 AGGSPLIT_FINAL_DESERIAL,
-										 parse->groupClause,
-										 (List *) parse->havingQual,
-										 &agg_final_costs,
-										 dNumGroups));
-			else
-				add_path(grouped_rel, (Path *)
-						 create_group_path(root,
+		/*
+		 * The same for the grouped partial paths involving base relation /
+		 * join grouping.
+		 */
+		if (input_rel->gpi != NULL && input_rel->gpi->target != NULL &&
+			input_rel->gpi->partial_pathlist)
+			sort_agg_partial_grouped_paths(root,
+										   input_rel->gpi->partial_pathlist,
+										   &agg_final_costs, dNumGroups,
 										   grouped_rel,
-										   path,
-										   target,
-										   parse->groupClause,
-										   (List *) parse->havingQual,
-										   dNumGroups));
-
-			/*
-			 * The point of using Gather Merge rather than Gather is that it
-			 * can preserve the ordering of the input path, so there's no
-			 * reason to try it unless (1) it's possible to produce more than
-			 * one output row and (2) we want the output path to be ordered.
-			 */
-			if (parse->groupClause != NIL && root->group_pathkeys != NIL)
-			{
-				foreach(lc, grouped_rel->partial_pathlist)
-				{
-					Path	   *subpath = (Path *) lfirst(lc);
-					Path	   *gmpath;
-					double		total_groups;
-
-					/*
-					 * It's useful to consider paths that are already properly
-					 * ordered for Gather Merge, because those don't need a
-					 * sort.  It's also useful to consider the cheapest path,
-					 * because sorting it in parallel and then doing Gather
-					 * Merge may be better than doing an unordered Gather
-					 * followed by a sort.  But there's no point in
-					 * considering non-cheapest paths that aren't already
-					 * sorted correctly.
-					 */
-					if (path != subpath &&
-						!pathkeys_contained_in(root->group_pathkeys,
-											   subpath->pathkeys))
-						continue;
-
-					total_groups = subpath->rows * subpath->parallel_workers;
-
-					gmpath = (Path *)
-						create_gather_merge_path(root,
-												 grouped_rel,
-												 subpath,
-												 partial_grouping_target,
-												 root->group_pathkeys,
-												 NULL,
-												 &total_groups);
-
-					if (parse->hasAggs)
-						add_path(grouped_rel, (Path *)
-								 create_agg_path(root,
-												 grouped_rel,
-												 gmpath,
-												 target,
-												 parse->groupClause ? AGG_SORTED : AGG_PLAIN,
-												 AGGSPLIT_FINAL_DESERIAL,
-												 parse->groupClause,
-												 (List *) parse->havingQual,
-												 &agg_final_costs,
-												 dNumGroups));
-					else
-						add_path(grouped_rel, (Path *)
-								 create_group_path(root,
-												   grouped_rel,
-												   gmpath,
-												   target,
-												   parse->groupClause,
-												   (List *) parse->havingQual,
-												   dNumGroups));
-				}
-			}
-		}
+										   input_rel->gpi->target,
+										   target);
 	}
 
 	if (can_hash)
@@ -4143,11 +4096,27 @@ create_grouping_paths(PlannerInfo *root,
 										 parse->groupClause,
 										 (List *) parse->havingQual,
 										 agg_costs,
-										 dNumGroups));
+										 dNumGroups), false);
 			}
 		}
 
 		/*
+		 * Compute agg_final_costs if needed below and if not done above.
+		 */
+		if (parse->hasAggs && !agg_final_costs_known &&
+			(grouped_rel->partial_pathlist ||
+			 (input_rel->gpi != NULL &&
+			  (input_rel->gpi->pathlist || input_rel->gpi->partial_pathlist))))
+		{
+			get_agg_clause_costs(root, (Node *) target->exprs,
+								 AGGSPLIT_FINAL_DESERIAL,
+								 &agg_final_costs);
+			get_agg_clause_costs(root, parse->havingQual,
+								 AGGSPLIT_FINAL_DESERIAL,
+								 &agg_final_costs);
+		}
+
+		/*
 		 * Generate a HashAgg Path atop of the cheapest partial path. Once
 		 * again, we'll only do this if it looks as though the hash table
 		 * won't exceed work_mem.
@@ -4156,33 +4125,82 @@ create_grouping_paths(PlannerInfo *root,
 		{
 			Path	   *path = (Path *) linitial(grouped_rel->partial_pathlist);
 
+			hash_agg_partial_grouped_path(root, path, &agg_final_costs,
+										  dNumGroups, grouped_rel,
+										  partial_grouping_target, target);
+		}
+
+		/*
+		 * If input_rel has partially aggregated paths, perform the final
+		 * aggregation.
+		 */
+		if (input_rel->gpi != NULL && input_rel->gpi->pathlist != NIL)
+		{
+			Path	   *path = (Path *) linitial(input_rel->gpi->pathlist);
+
 			hashaggtablesize = estimate_hashagg_tablesize(path,
 														  &agg_final_costs,
 														  dNumGroups);
 
 			if (hashaggtablesize < work_mem * 1024L)
 			{
-				double		total_groups = path->rows * path->parallel_workers;
+				/*
+				 * The top-level grouped_rel needs to receive the path into
+				 * regular pathlist, as opposed grouped_rel->gpi->pathlist. So
+				 * pass FALSE for grouped.
+				 */
+				add_path(grouped_rel,
+						 (Path *) create_agg_path(root, grouped_rel,
+												  path,
+												  target,
+												  AGG_HASHED,
+												  AGGSPLIT_FINAL_DESERIAL,
+												  parse->groupClause,
+												  (List *) parse->havingQual,
+												  &agg_final_costs,
+												  dNumGroups),
+						 false);
+			}
+		}
 
-				path = (Path *) create_gather_path(root,
-												   grouped_rel,
-												   path,
-												   partial_grouping_target,
-												   NULL,
-												   &total_groups);
+		/*
+		 * If input_rel has partially aggregated partial paths, gather them
+		 * and perform the final aggregation.
+		 */
+		if (input_rel->gpi != NULL && input_rel->gpi->target != NULL &&
+			input_rel->gpi->partial_pathlist != NIL)
+		{
+			Path	   *path = (Path *) linitial(input_rel->gpi->partial_pathlist);
 
-				add_path(grouped_rel, (Path *)
-						 create_agg_path(root,
-										 grouped_rel,
-										 path,
-										 target,
-										 AGG_HASHED,
-										 AGGSPLIT_FINAL_DESERIAL,
-										 parse->groupClause,
-										 (List *) parse->havingQual,
-										 &agg_final_costs,
-										 dNumGroups));
-			}
+			hash_agg_partial_grouped_path(root, path, &agg_final_costs, dNumGroups,
+										  grouped_rel, input_rel->gpi->target,
+										  target);
+		}
+	}
+
+	/*
+	 * If input_rel has partially aggregated paths which emit an unique set of
+	 * grouping keys, we only need to call aggfinalfn on each aggregate state
+	 * instead of doing the final aggregation
+	 */
+	if (input_rel->gpi != NULL && !parse->groupingSets)
+	{
+		foreach(lc, input_rel->gpi->pathlist)
+		{
+			Path	   *path = (Path *) lfirst(lc);
+
+			/*
+			 * If aggregation could have been pushed down and if the path
+			 * generates unique grouping keys, replace aggregates with the
+			 * aggregate final functions alone.
+			 */
+			if ((parse->groupClause || parse->hasAggs || root->hasHavingQual)
+				&& root->grouped_var_list != NIL &&
+				match_path_to_group_pathkeys(root, path))
+				add_path(grouped_rel,
+						 adjust_path_for_unique_group_keys(root, path,
+														   target),
+						 false);
 		}
 	}
 
@@ -4383,7 +4401,7 @@ consider_groupingsets_paths(PlannerInfo *root,
 										  strat,
 										  new_rollups,
 										  agg_costs,
-										  dNumGroups));
+										  dNumGroups), false);
 		return;
 	}
 
@@ -4541,7 +4559,7 @@ consider_groupingsets_paths(PlannerInfo *root,
 											  AGG_MIXED,
 											  rollups,
 											  agg_costs,
-											  dNumGroups));
+											  dNumGroups), false);
 		}
 	}
 
@@ -4558,7 +4576,174 @@ consider_groupingsets_paths(PlannerInfo *root,
 										  AGG_SORTED,
 										  gd->rollups,
 										  agg_costs,
-										  dNumGroups));
+										  dNumGroups), false);
+}
+
+/*
+ * Subroutine of create_grouping_paths() to apply GatherPath or
+ * GatherMergePath and AGG_SORTED AggPath to cases which only differ in the
+ * GatherPath / GatherMergePath target.
+ */
+static void
+sort_agg_partial_grouped_paths(PlannerInfo *root, List *pathlist,
+							   AggClauseCosts *agg_final_costs,
+							   double dNumGroups, RelOptInfo *grouped_rel,
+							   PathTarget *gather_target,
+							   PathTarget *group_target)
+{
+	Path	   *path = (Path *) linitial(pathlist);
+	double		total_groups = path->rows * path->parallel_workers;
+	Query	   *parse = root->parse;
+	ListCell   *lc;
+
+	/*
+	 * Generate a complete GroupAgg Path atop of the cheapest partial path. We
+	 * can do this using either Gather or Gather Merge.
+	 */
+	path = (Path *) create_gather_path(root,
+									   grouped_rel,
+									   path,
+									   gather_target,
+									   NULL,
+									   &total_groups);
+
+	/*
+	 * Since Gather's output is always unsorted, we'll need to sort, unless
+	 * there's no GROUP BY clause or a degenerate (constant) one, in which
+	 * case there will only be a single group.
+	 */
+	if (root->group_pathkeys)
+		path = (Path *) create_sort_path(root,
+										 grouped_rel,
+										 path,
+										 root->group_pathkeys,
+										 -1.0);
+
+	if (parse->hasAggs)
+		add_path(grouped_rel, (Path *)
+				 create_agg_path(root,
+								 grouped_rel,
+								 path,
+								 group_target,
+								 parse->groupClause ? AGG_SORTED : AGG_PLAIN,
+								 AGGSPLIT_FINAL_DESERIAL,
+								 parse->groupClause,
+								 (List *) parse->havingQual,
+								 agg_final_costs,
+								 dNumGroups), false);
+	else
+		add_path(grouped_rel, (Path *)
+				 create_group_path(root,
+								   grouped_rel,
+								   path,
+								   group_target,
+								   parse->groupClause,
+								   (List *) parse->havingQual,
+								   dNumGroups), false);
+
+	/*
+	 * The point of using Gather Merge rather than Gather is that it can
+	 * preserve the ordering of the input path, so there's no reason to try it
+	 * unless (1) it's possible to produce more than one output row and (2) we
+	 * want the output path to be ordered.
+	 */
+	if (parse->groupClause != NIL && root->group_pathkeys != NIL)
+	{
+		foreach(lc, pathlist)
+		{
+			Path	   *subpath = (Path *) lfirst(lc);
+			Path	   *gmpath;
+			double		total_groups;
+
+			/*
+			 * It's useful to consider paths that are already properly ordered
+			 * for Gather Merge, because those don't need a sort.  It's also
+			 * useful to consider the cheapest path, because sorting it in
+			 * parallel and then doing Gather Merge may be better than doing
+			 * an unordered Gather followed by a sort.  But there's no point
+			 * in considering non-cheapest paths that aren't already sorted
+			 * correctly.
+			 */
+			if (path != subpath &&
+				!pathkeys_contained_in(root->group_pathkeys,
+									   subpath->pathkeys))
+				continue;
+
+			total_groups = subpath->rows * subpath->parallel_workers;
+
+			gmpath = (Path *)
+				create_gather_merge_path(root,
+										 grouped_rel,
+										 subpath,
+										 gather_target,
+										 root->group_pathkeys,
+										 NULL,
+										 &total_groups);
+
+			if (parse->hasAggs)
+				add_path(grouped_rel, (Path *)
+						 create_agg_path(root,
+										 grouped_rel,
+										 gmpath,
+										 group_target,
+										 parse->groupClause ? AGG_SORTED : AGG_PLAIN,
+										 AGGSPLIT_FINAL_DESERIAL,
+										 parse->groupClause,
+										 (List *) parse->havingQual,
+										 agg_final_costs,
+										 dNumGroups), false);
+			else
+				add_path(grouped_rel, (Path *)
+						 create_group_path(root,
+										   grouped_rel,
+										   gmpath,
+										   group_target,
+										   parse->groupClause,
+										   (List *) parse->havingQual,
+										   dNumGroups), false);
+		}
+	}
+}
+
+/*
+ * Subroutine of create_grouping_paths() to apply GatherPath and AGG_HASHED
+ * AggPath to cases which only differ in the GatherPath target.
+ */
+static void
+hash_agg_partial_grouped_path(PlannerInfo *root, Path *path,
+							  AggClauseCosts *agg_final_costs,
+							  double dNumGroups, RelOptInfo *grouped_rel,
+							  PathTarget *gather_target,
+							  PathTarget *group_target)
+{
+	Size		hashaggtablesize = estimate_hashagg_tablesize(path, agg_final_costs,
+															  dNumGroups);
+	Query	   *parse = root->parse;
+	double		total_groups;
+
+	if (hashaggtablesize >= work_mem * 1024L)
+		return;
+
+	total_groups = path->rows * path->parallel_workers;
+
+	path = (Path *) create_gather_path(root,
+									   grouped_rel,
+									   path,
+									   gather_target,
+									   NULL,
+									   &total_groups);
+
+	add_path(grouped_rel, (Path *)
+			 create_agg_path(root,
+							 grouped_rel,
+							 path,
+							 group_target,
+							 AGG_HASHED,
+							 AGGSPLIT_FINAL_DESERIAL,
+							 parse->groupClause,
+							 (List *) parse->havingQual,
+							 agg_final_costs,
+							 dNumGroups), false);
 }
 
 /*
@@ -4743,7 +4928,7 @@ create_one_window_path(PlannerInfo *root,
 								  window_pathkeys);
 	}
 
-	add_path(window_rel, path);
+	add_path(window_rel, path, false);
 }
 
 /*
@@ -4849,7 +5034,8 @@ create_distinct_paths(PlannerInfo *root,
 						 create_upper_unique_path(root, distinct_rel,
 												  path,
 												  list_length(root->distinct_pathkeys),
-												  numDistinctRows));
+												  numDistinctRows),
+						 false);
 			}
 		}
 
@@ -4876,7 +5062,8 @@ create_distinct_paths(PlannerInfo *root,
 				 create_upper_unique_path(root, distinct_rel,
 										  path,
 										  list_length(root->distinct_pathkeys),
-										  numDistinctRows));
+										  numDistinctRows),
+				 false);
 	}
 
 	/*
@@ -4923,7 +5110,7 @@ create_distinct_paths(PlannerInfo *root,
 								 parse->distinctClause,
 								 NIL,
 								 NULL,
-								 numDistinctRows));
+								 numDistinctRows), false);
 	}
 
 	/* Give a helpful error if we failed to find any implementation */
@@ -5021,7 +5208,7 @@ create_ordered_paths(PlannerInfo *root,
 				path = apply_projection_to_path(root, ordered_rel,
 												path, target);
 
-			add_path(ordered_rel, path);
+			add_path(ordered_rel, path, false);
 		}
 	}
 
@@ -5072,7 +5259,7 @@ create_ordered_paths(PlannerInfo *root,
 				path = apply_projection_to_path(root, ordered_rel,
 												path, target);
 
-			add_path(ordered_rel, path);
+			add_path(ordered_rel, path, false);
 		}
 	}
 
@@ -5990,7 +6177,8 @@ adjust_paths_for_srfs(PlannerInfo *root, RelOptInfo *rel,
 				newpath = (Path *) create_projection_path(root,
 														  rel,
 														  newpath,
-														  thistarget);
+														  thistarget,
+														  false);
 			}
 		}
 		lfirst(lc) = newpath;
@@ -5998,6 +6186,86 @@ adjust_paths_for_srfs(PlannerInfo *root, RelOptInfo *rel,
 }
 
 /*
+ * Project a path that generates unique grouping keys to a new one whose
+ * target, instead of the (partial) aggregates, contains the aggregates' final
+ * functions, each referencing the corresponding partial aggregate.
+ */
+static Path *
+adjust_path_for_unique_group_keys(PlannerInfo *root, Path *path,
+								  PathTarget *target)
+{
+	ListCell   *lc1;
+	PathTarget *target_new;
+	List	   *exprs = NIL;
+
+	target_new = copy_pathtarget(target);
+
+	/*
+	 * Replace (partial) aggregates with aggfinalfn function calls.
+	 */
+	foreach(lc1, target_new->exprs)
+	{
+		Expr	   *expr = (Expr *) lfirst(lc1);
+
+		if (IsA(expr, Aggref))
+		{
+			ListCell   *lc2;
+			Aggref	   *aggref = castNode(Aggref, expr);
+			GroupedVar *gvar = NULL;
+
+			/*
+			 * Find GroupedVar for this aggregate --- the input path should
+			 * contain it too. Put it to the target for set_upper_references
+			 * to be able to match the output and input target.
+			 */
+			foreach(lc2, path->pathtarget->exprs)
+			{
+				Expr	   *texpr = (Expr *) lfirst(lc2);
+
+				if (IsA(texpr, GroupedVar))
+				{
+					gvar = castNode(GroupedVar, texpr);
+
+					if (equal(gvar->gvexpr, aggref))
+						break;
+				}
+			}
+			/* The GroupedVar should have been found. */
+			Assert(lc2 != NULL);
+
+			/*
+			 * Arrange for the call of aggfinalfn or let the transient state
+			 * appear on the output unprocessed.
+			 */
+			if (OidIsValid(aggref->aggfinalfn))
+			{
+				FuncExpr   *fexpr = makeNode(FuncExpr);
+
+				fexpr = makeNode(FuncExpr);
+				fexpr->funcid = aggref->aggfinalfn;
+				fexpr->funcresulttype = aggref->aggtype;
+				fexpr->funcretset = false;
+				fexpr->funcvariadic = aggref->aggvariadic;
+				fexpr->funcformat = COERCE_EXPLICIT_CALL;
+				fexpr->funccollid = aggref->aggcollid;
+				fexpr->inputcollid = aggref->inputcollid;
+				fexpr->args = list_make1(gvar);
+				fexpr->location = -1;
+				expr = (Expr *) fexpr;
+			}
+			else
+				expr = (Expr *) gvar;
+		}
+
+		exprs = lappend(exprs, expr);
+	}
+	target_new->exprs = exprs;
+
+	return (Path *) create_projection_path(root, path->parent, path,
+										   target_new, false);
+}
+
+/*
  * expression_planner
  *		Perform planner's transformations on a standalone expression.
  *
